
//     CATTLE DOCK #8A
//     Hubert SPERI
//     27/12/2021
//     Modifié : 31/01/2022
//_________________________

//ADUINO UNO ou NANO
//DFPlayer MINI : lecteur de fichier MP3
//_________________________

// TOUCHES UTILISÉES POUR LA MISE EN ROUTE
// -- code «6» + «POWER» ⇒ mise en route avec le volume 10 ;
// -- code «60» ⇒ mise en route avec le volume 12 ;
// -- code «61» ⇒ mise en route avec le volume 15 ;
// -- code «62» ⇒ mise en route avec le volume 18 ;
// -- code «63» ⇒ mise en route avec le volume 21 ;
// -- code «64» ⇒ mise en route avec le volume 24 ;
// -- code «65» ⇒ mise en route avec le volume 27 ;


// TOUCHES UTILISÉES PENDANT LE FONCTIONNEMENT
// -- code «6» + «Touche_VolUp»   ⇒ augmentation du volume de 2 crans ;
// -- code «6» + «Touche_VolDown» ⇒ diminution du volume de 2 crans ;
// -- code «60» ⇒ volume 12 ;
// -- code «61» ⇒ volume 18 ;
// -- code «62» ⇒ DFPLAYER_EQ_JAZZ ;
// -- code «63» ⇒ DFPLAYER_EQ_POP ;
// -- code «64» ⇒ advertise : interruption pour diffuser un autre son ;
// -- code «65» ⇒ advertise : interruption pour diffuser un autre son ;
// -- code «66» ⇒ advertise : interruption pour diffuser un autre son ;
// -- code «67» ⇒ advertise : interruption pour diffuser un autre son ;
// -- code «68» ⇒ advertise : interruption pour diffuser un autre son ;
// -- code «69» ⇒ arrêt ; (provisoire)
// -- code «6» + «POWER» ⇒ arrêt ;

//_________________________

//SEQUENCE SONORES
//
//
//L'ordre des sons dépend de l'ordre dans lequel ils ont été copiés sur la carte «T», et pas de leur numérotation.
// Cependant, la numérotation «00x_[description].mp3» est utile pour gérer la programmation et l'utilisation des sons.

// Pour «advertise» :
// -- les sons doivent être déposés dans un répertoire nommé IMPÉRATIVEMENT «ADVERT» (en majuscules) ;
// -- les séquences sonores doivent être IMPÉRATIVEMENT et STRICTEMENT nommées : «0001.mp3», «0002.mp3»..., 
//    sans autre fioritures.
// -- l'extension «.wav» est valide aussi.
//_________________________

//ENTREES - SORTIES

//-- capteur infrarouge : entrée «2» ;
//-- «BUSY» du DFPlayer ⇒ broche «5» de l'ARDUINO ;

//-- Rx de l'ARDUINO : broche «11», reliée à la broche «Tx» du DFPlayer ;
//-- Tx de l'ARDUINO : broche «12», reliée à la broche «Rx» du DFPlayer ;

//Note : dans ce programme, la liason «Rx ARDUINO» vers «Tx DFPlayer» n'est pas utile.

//On n'utilise pas la broche «BUSY» du DFPlayer.







#include <IRremote.h>
#include <SoftwareSerial.h>
#include <DFRobotDFPlayerMini.h>

SoftwareSerial mySoftwareSerial(11,12); // la broche «11» de l'ARDUINO est utilisée comme «Rx» pour communiquer avec la broche «Tx» du DFPlayer.
                                        // la broche «12» de l'ARDUINO est utilisée comme «Tx» pour communiquer avec la broche «Rx» du DFPlayer.
                                        // Note : la liaison «Rx ARDUINO» --> «Tx DFPlayer» n'est pas utilisée dans ce programme.
                                        
DFRobotDFPlayerMini myDFPlayer;         // Déclare une instance pour le DFPlayer.

int IRpin = 2;                          // Entrée du capteur IR
IRrecv irrecv(IRpin);
decode_results results;

const int  Touche_9 = 272 ; 
const int  Touche_8 = 3600 ;
const int  Touche_7 = 1552 ;
const int  Touche_6 = 2576 ;
const int  Touche_5 = 528 ;
const int  Touche_4 = 3088 ;
const int  Touche_3 = 1040 ;
const int  Touche_2 = 2064 ;
const int  Touche_1 = 16 ;
const int  Touche_0 = 2320 ;
//const int  Touche_Up = 1904 ;
//const int  Touche_Down = 3952 ;
//const int  Touche_Left = 2800 ;
//const int  Touche_Right = 752 ;
const int  Touche_VolUp = 1168 ;
const int  Touche_VolDown = 3216 ;
//const int  Touche_CH_Up = 144 ;
//const int  Touche_CH_Down = 2192 ;
const int  Touche_POWER = 2704 ;
//const int  Touche_Menu =112 ;
  






// (Appelée par la fonction «Numero_du_son»)
// Cette fonction attend indéfiniment la saisie du premier code.

int Interception_du_premier_code_IR_SONY() 
{
int Code_touche_obtenu = 999 ;
irrecv.resume() ;
    
               //int Temps_IN = millis() / 1000 ;
            while (!(irrecv.decode(&results)))         // Attend indéfiniment (sans rien faire) la réception du 2e code.
                  {
                  // boucle d'attente
                  delay(100) ;
               // int Temps_OUT = millis() / 1000 ;
               // if ((Temps_OUT - Temps_IN) > 2) {return 999 ; }
                  }
             Code_touche_obtenu = results.value ;  
                  Serial.print("Code touche obtenu = ") ;
                  Serial.println(Code_touche_obtenu) ;
                                        
             delay(600) ;    // Delai avant la saisie du 2e code.
                             // Nécessaire pour avoir le temps de relâcher la touche.
             irrecv.resume() ;
                                       
             return Code_touche_obtenu ;            
}  





// (Appelée par la fonction «Numero_du_son»)
// Pour le 2e code, le délai de saisie est limité à 2 secondes.
// Passé ce délai, on revient au début de void loop pour attendre un nouveau premier code.

int Interception_du_deuxieme_code_IR_SONY() 
{
int Code_touche_obtenu = 999 ;
irrecv.resume() ;
  
            int Temps_IN = millis() / 1000 ;
            while (!(irrecv.decode(&results)))         // Attend la réception du 2e code pendant 2 secondes.
                  {
                  // boucle d'attente à durée limitée.
                  delay(100) ;
                  int Temps_OUT = millis() / 1000 ;
                  if ((Temps_OUT - Temps_IN) > 2) {Serial.print("Dépassement du temps ") ; return 999 ; }
                  }
             Code_touche_obtenu = results.value ;  
                  Serial.print("Code touche obtenu = ") ;
                  Serial.println(Code_touche_obtenu) ;
                                                  
             irrecv.resume() ;
                                        
             delay(1000) ;    // Delai avant la saisie du code suivant
             results.value = 0 ;
             irrecv.resume() ;
                                        
             return Code_touche_obtenu ;            
}  








int Numero_du_son()
   {      
// PRINCIPE DE LA FONCTION «Numero_du_son()» :
//    -- on récupère successivement le deux chiffres du code ;
//    ⇒ ces codes sont peut-être invalides : faux code, mauvaise réception ou réception accidentelle du code
//       destiné à un autre récepteur ;
//    -- on traite donc tous les cas valides, et seulement eux ;
//    -- ce traitement des codes valides fait que la fonction «numero_du_son» prend comme valeur, le n° du son choisi.
//    ⇒ dans le cas présent, comme il n'y a qu'une seule séquence sonore,
//       la valeur prise par la fonction sera forcément «1».

    int Numero = 1 ;
    int Premier_chiffre = 99 ;   // initialise les 2 digits à une valeur qui n'existe pas.
    int Deuxieme_chiffre = 99 ;  // Ainsi, une mauvaise réception accidentelle ou la réception d'un code non valide
                                 // sera traduite par le code «99» qui est un code non valide;
    
    Premier_chiffre = Interception_du_premier_code_IR_SONY() ;
    Deuxieme_chiffre = Interception_du_deuxieme_code_IR_SONY() ;
    
   // Décade 6 -------------------------------------- 
   if (Premier_chiffre == Touche_6) 
     {
        if (Deuxieme_chiffre == Touche_POWER)      {Numero = 1 ; myDFPlayer.volume(10); }
             // ... et pour s'amuser un peu...        
        if (Deuxieme_chiffre == Touche_0)          {Numero = 1 ; myDFPlayer.volume(12); }     
        if (Deuxieme_chiffre == Touche_1)          {Numero = 1 ; myDFPlayer.volume(15); }  
        if (Deuxieme_chiffre == Touche_2)          {Numero = 1 ; myDFPlayer.volume(18); }        
        if (Deuxieme_chiffre == Touche_3)          {Numero = 1 ; myDFPlayer.volume(21); }        
        if (Deuxieme_chiffre == Touche_4)          {Numero = 1 ; myDFPlayer.volume(24); }        
        if (Deuxieme_chiffre == Touche_5)          {Numero = 1 ; myDFPlayer.volume(27); }             
        if (Deuxieme_chiffre == Touche_6)          {loop() ; }     
        if (Deuxieme_chiffre == Touche_7)          {loop() ; }     
        if (Deuxieme_chiffre == Touche_8)          {loop() ; }        
        if (Deuxieme_chiffre == Touche_9)          {loop() ; }
             // par contre, ce qui suit est indispensable :
        else if (Deuxieme_chiffre == 99)           {loop() ; }
      } 
      return Numero ; 
   }






int Modification_du_son()
   {
// Cette fonction utilise les mêmes codes que la fonction «Numero_du_son()».
// Cette fonction est appelée pendant que le programme attend la fin de la diffusion du son, donc
//    elle ne fait que modifier le son, mais ne relance pas le programme.

    int Premier_chiffre = 99 ;
    int Deuxieme_chiffre = 99 ;
    Premier_chiffre = Interception_du_premier_code_IR_SONY() ;
    Deuxieme_chiffre = Interception_du_deuxieme_code_IR_SONY() ;
    
   // Décade 6 -------------------------------------- 
   if (Premier_chiffre == Touche_6) 
     {
        if (Deuxieme_chiffre == Touche_POWER)      {myDFPlayer.stop(); loop() ; }     
        if (Deuxieme_chiffre == Touche_VolUp)      {myDFPlayer.volumeUp(); myDFPlayer.volumeUp(); }     
        if (Deuxieme_chiffre == Touche_VolDown)    {myDFPlayer.volumeDown(); myDFPlayer.volumeDown(); }  
        if (Deuxieme_chiffre == Touche_0)          {myDFPlayer.volume(12); }      
        if (Deuxieme_chiffre == Touche_1)          {myDFPlayer.volume(18); }                  
        if (Deuxieme_chiffre == Touche_2)          {myDFPlayer.EQ(DFPLAYER_EQ_JAZZ); }        
        if (Deuxieme_chiffre == Touche_3)          {myDFPlayer.EQ(DFPLAYER_EQ_POP); } 
        if (Deuxieme_chiffre == Touche_4)          {myDFPlayer.advertise(1); }        
        if (Deuxieme_chiffre == Touche_5)          {myDFPlayer.advertise(2); }                     
        if (Deuxieme_chiffre == Touche_6)          {myDFPlayer.advertise(3); }     
        if (Deuxieme_chiffre == Touche_7)          {myDFPlayer.advertise(4); }     
        if (Deuxieme_chiffre == Touche_8)          {myDFPlayer.advertise(5); }        
        if (Deuxieme_chiffre == Touche_9)          {myDFPlayer.stop(); loop() ; }
        else if (Deuxieme_chiffre == 99)           {return ; }
      }  
   }








void Attente_fin_du_son() 
{
  // La pin «BUSY» est reliée à la pin «5» sur l'ARDUINO.
  
  delay(1000); // ... pour être sûr que la lecture du son a commencé, 
               //donc que BUSY est à «LOW».
  while (digitalRead(5) == LOW) 
      {
      // attend un éventuel code de modification du son ou le code d'arrêt,
      // tant que le son est en cours de lecture.
      Modification_du_son() ;
      }
}







void setup() 
  {
  irrecv.enableIRIn();

  mySoftwareSerial.begin(9600);           // pour communiquer avec le DFPlayer
  myDFPlayer.begin(mySoftwareSerial);
  
  //  ----EQUALIZER : PARAMETRAGES POSSIBLES
  //  myDFPlayer.EQ(DFPLAYER_EQ_NORMAL);
  //  myDFPlayer.EQ(DFPLAYER_EQ_POP);
  //  myDFPlayer.EQ(DFPLAYER_EQ_ROCK);
  myDFPlayer.EQ(DFPLAYER_EQ_JAZZ);
  //  myDFPlayer.EQ(DFPLAYER_EQ_CLASSIC);
  //  myDFPlayer.EQ(DFPLAYER_EQ_BASS);
 
  Serial.begin(9600);                     // Pour communiquer avec le moniteur
  pinMode(13, OUTPUT);                    // LED de contrôle de la réception d'un code.

  }






void loop() 
  { 
  Serial.println("-------------------------") ;
  Serial.println("Attente du code démarrage") ;
   
  irrecv.resume();          // Receive the next value  
    
  myDFPlayer.play(Numero_du_son() );
  Attente_fin_du_son() ;   
     
  }


  
